﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace SciLor_s_Mashed_Runner {
    class Mashed {

        [DllImport("user32.dll")]
        private static extern void SwitchToThisWindow(IntPtr hWnd, bool fAltTab);

        public const String EMPTY_VIDEO = "SciLorsEmptyVideo.mpg";
        public const String BASE_VIDEO_DIR = @"TOASTART\PC\MOVIES\";
        public static String[] VIDEO_NAMES = { 
                                                  "empire.mpg",
                                                  "intro.mpg",
                                                  "renderware.mpg",
                                                  "small.mpg",
                                                  "supersonic.mpg"
                                              };

        public const String EXE = "MFL.exe";
        public const String SAVE = ""; //@"save\";

        public static IconFile[] ICOS = {
            new IconFile(@"TOASTART\Common\PANEL\NFLRed.png"),
            new IconFile(@"TOASTART\Common\PANEL\NFLBluejay.png"),
            new IconFile(@"TOASTART\Common\PANEL\NFLGold.png"),
            new IconFile(@"TOASTART\Common\PANEL\NFLMelon.png"),
            new IconFile(@"TOASTART\Common\PANEL\NFLPink.png"),
            new IconFile(@"TOASTART\Common\PANEL\NFLShadow.png"),
                                              };

        public const String ICO = @"TOASTART\Common\PANEL\NFLRed.png";
        public const String ICO_SMALL = "mashed.ICO";

        public static void Run(bool video, bool control, bool exit, frmMashed form) { //-VS0 -CS0 -L2
            if (!checkExe()) return;
            form.Enabled = false;
            //form.WindowState = FormWindowState.Minimized;

            int lang = 0;
            if (form.cmbLanguage.SelectedItem != null) {
                Language langObj = (Language)form.cmbLanguage.SelectedItem;
                lang = langObj.Id;
            }

            Process p = new Process();
            p.StartInfo.FileName = Properties.Settings.Default.Path + Mashed.EXE;
            p.StartInfo.Arguments = "-VS" + bool2int(video) + " " + "-CS" + bool2int(control) + " " + "-L" + lang;
            p.StartInfo.WorkingDirectory = Properties.Settings.Default.Path + Mashed.SAVE;
            p.Start();

            if (exit) {
                form.Close();
                Application.Exit();
            } else {
                p.WaitForExit();
                form.Enabled = true;
                form.Refresh();
                if (form.WindowState != FormWindowState.Minimized) 
                    form.WindowState = FormWindowState.Minimized;
                //form.WindowState = FormWindowState.Normal;
                SwitchToThisWindow(form.Handle, true);
                form.Show();

            }
        }
        private static int bool2int(bool value) {
            if (value) return 1;
            return 0;
        }

        public static bool checkExe() {
            if (!System.IO.File.Exists(Util.GetMashedDir() + Mashed.EXE)) {
                MessageBox.Show(Mashed.EXE + " " + "not found" + "\r\n" +
                    "Please copy this application into the Mashed - Fully Loaded directory" + "\r\n" +
                    "or select the right path to its executable.",
                    "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return false;
            }
            return true;
        }
    }
}
